<template>
  <div v-if="show" class="flex justify-end items-center">
    <svn-icon-button
      :icon="icon"
      :variant="variant"
      :button-size="buttonSize"
      :disable="disable"
      :to="to"
      :danger="danger"
      :circle="circle"
      :color-class="colorClass"
    />

    <v-menu v-if="!disable" activator="parent" :location="table ? 'bottom end' : undefined" :origin="table ? 'top end' : 'auto'">
      <v-list class="py-0">
        <slot name="before" />

        <div class="flex flex-col">
          <slot name="items">
            <v-list-item class="cursor-pointer hover:bg-neutral-300">
              <svn-dialog-skeleton bind />
            </v-list-item>

            <v-list-item class="cursor-pointer hover:bg-neutral-300">
              This is an element
            </v-list-item>

            <v-list-item class="cursor-pointer hover:bg-neutral-300">
              This is another element
            </v-list-item>
          </slot>
        </div>

        <slot name="after" />
      </v-list>
    </v-menu>
  </div>
</template>

<script setup>
import SvnIconButton from "./button/SvnIconButton.vue";
import SvnDialogSkeleton from "./skeleton/SvnDialogSkeleton.vue";

const props = defineProps({
  icon: {
    type: String,
    default: 'mdi:dots-vertical'
  },
  variant: {
    type: String,
    default: 'plain'
  },
  buttonSize: {
    type: String,
    default: 'md'
  },
  show: {
    type: Boolean,
    default: true
  },
  disable: {
    type: Boolean,
    default: false
  },
  table: {
    type: Boolean,
    default: false
  },
  to: {
    type: String,
    default: null
  },
  danger: {
    type: Boolean,
    default: false
  },
  circle: {
    type: Boolean,
    default: false
  },
  colorClass: {
    type: String,
    default: ''
  }
});
</script>